Index: java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 88)
@@ -0,0 +1,187 @@
+package com.framsticks.util.dispatching;
+
+import java.util.Collections;
+import java.util.HashSet;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Set;
+
+import javax.annotation.Nonnull;
+
+import org.apache.commons.collections.CollectionUtils;
+import org.apache.log4j.Logger;
+
+import com.framsticks.util.FramsticksException;
+
+
+
+public abstract class AbstractJoinable implements Joinable {
+	private static final Logger log = Logger.getLogger(AbstractJoinable.class);
+
+
+	protected final Set<JoinableParent> owners = new HashSet<JoinableParent>();
+	protected final Set<JoinableParent> joinableListeners = new HashSet<JoinableParent>();
+
+	protected static final Set<AbstractJoinable> joinablesRegistry = Collections.synchronizedSet(new HashSet<AbstractJoinable>());
+
+	JoinableState state = JoinableState.INITILIAZED;
+
+	/**
+	 *
+	 */
+	public AbstractJoinable() {
+		joinablesRegistry.add(this);
+	}
+
+	public static void report() {
+		StringBuilder b = new StringBuilder();
+		synchronized (joinablesRegistry) {
+			for (AbstractJoinable j : joinablesRegistry) {
+				b.append("\n").append(j.getState()).append(" : ").append(j);
+			}
+		}
+		log.debug("state: " + b);
+	}
+
+	private synchronized boolean changeState(JoinableState state) {
+		if (this.state.ordinal() >= state.ordinal()) {
+			return false;
+		}
+		if (this.state.ordinal() + 1 != state.ordinal()) {
+			throw new FramsticksException().msg("failed to change state").arg("from", this.state).arg("to", state).arg("joinable", this);
+		}
+		this.state = state;
+
+		synchronized (this) {
+			log.debug(this + " is notifying " + joinableListeners.size() + " parents");
+
+			List<JoinableParent> parents = new LinkedList<>();
+			CollectionUtils.addAll(parents, joinableListeners.iterator());
+
+			for (JoinableParent p : parents) {
+				if (p != null) {
+					Dispatching.childChangedState(p, this, state);
+				}
+			}
+		}
+		report();
+
+		return true;
+	}
+
+
+
+	public final boolean start() {
+		if (changeState(JoinableState.RUNNING)) {
+			joinableStart();
+			return true;
+		}
+		return false;
+	}
+
+	public final boolean interrupt() {
+		if (changeState(JoinableState.FINISHING)) {
+			joinableInterrupt();
+			return true;
+		}
+		return false;
+	}
+
+	protected final boolean finish() {
+		if (changeState(JoinableState.JOINABLE)) {
+			joinableFinish();
+			return true;
+		}
+		return false;
+	}
+
+
+
+	@Override
+	public final void join() throws InterruptedException {
+		synchronized (this) {
+			if (this.state.equals(JoinableState.JOINED)) {
+				return;
+			}
+			if (!this.state.equals(JoinableState.JOINABLE)) {
+				throw new InterruptedException();
+			}
+		}
+		joinableJoin();
+		synchronized (this) {
+			this.state = JoinableState.JOINED;
+		}
+	}
+
+	protected final boolean proceedToState(JoinableState state) {
+		switch (state) {
+			case RUNNING:
+				return start();
+			case FINISHING:
+				return interrupt();
+			case JOINABLE:
+				return finish();
+			default: return false;
+		}
+	}
+
+	protected abstract void joinableStart();
+
+	protected abstract void joinableInterrupt();
+
+	protected abstract void joinableFinish();
+
+	protected abstract void joinableJoin() throws InterruptedException;
+
+	public final boolean use(@Nonnull JoinableParent owner) {
+		boolean start = false;
+		synchronized (this) {
+			assert !owners.contains(owner);
+			start = owners.isEmpty();
+			log.debug(owner + " is using " + this);
+			owners.add(owner);
+			joinableListeners.add(owner);
+		}
+		if (start) {
+			return this.start();
+		}
+		return false;
+	}
+
+	public final boolean drop(@Nonnull JoinableParent owner) {
+		boolean stop = false;
+		synchronized (this) {
+			if (!owners.contains(owner)) {
+				return false;
+				// throw new FramsticksException().msg("object is not owning that joinable").arg("joinable", this).arg("object", owner);
+			}
+			// assert owners.containsKey(owner);
+			log.debug(owner + " is droping " + this);
+			owners.remove(owner);
+			stop = owners.isEmpty();
+		}
+		if (stop) {
+			Dispatching.dispatcherGuardedInvoke(this, new RunAt<Object>() {
+				@Override
+				public void run() {
+					interrupt();
+				}
+			});
+			return true;
+		}
+		return stop;
+	}
+
+	/**
+	 * @return the state
+	 */
+	public JoinableState getState() {
+		return state;
+	}
+
+	protected boolean isInState(JoinableState state) {
+		return this.state.equals(state);
+	}
+
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 88)
@@ -1,3 +1,5 @@
 package com.framsticks.util.dispatching;
+
+import org.apache.log4j.Logger;
 
 import com.framsticks.util.StateFunctor;
@@ -7,4 +9,5 @@
  */
 public abstract class Dispatching {
+	private static final Logger log = Logger.getLogger(Dispatching.class);
 
 	public static boolean isThreadSafe() {
@@ -31,6 +34,6 @@
 
 	// public static boolean assertInvokeLater(Dispatcher dispatcher, RunAt runnable) {
-	// 	dispatcher.invokeLater(runnable);
-	// 	return true;
+	//	dispatcher.invokeLater(runnable);
+	//	return true;
 	// }
 
@@ -44,3 +47,84 @@
 	}
 
+	public static void sleep(int milliseconds) {
+		try {
+			java.lang.Thread.sleep(milliseconds, 0);
+		} catch (InterruptedException e) {
+
+		}
+	}
+
+	@SuppressWarnings("unchecked")
+	public static void dispatcherGuardedInvoke(Joinable joinable, RunAt<?> runnable) {
+		if (joinable instanceof Dispatcher) {
+			invokeLaterOrNow(Dispatcher.class.cast(joinable), runnable);
+			return;
+		}
+		runnable.run();
+	}
+
+	public static void use(final Joinable joinable, final JoinableParent owner) {
+		log.debug("using " + joinable + " by " + owner);
+		if (joinable.use(owner)) {
+			log.debug("started " + joinable);
+		} else {
+			log.debug("start of " + joinable + " already happened");
+		}
+	}
+
+
+	public static void drop(final Joinable joinable, final JoinableParent owner) {
+		log.debug("droping " + joinable + " by " + owner);
+		if (joinable.drop(owner)) {
+			log.debug("stoped " + joinable);
+		} else {
+			log.debug("stop of " + joinable + " deferred");
+		}
+	}
+
+	public static void join(Joinable joinable) throws InterruptedException {
+		log.debug("joining " + joinable);
+		try {
+			joinable.join();
+		} catch (InterruptedException e) {
+			log.debug("failed to join " + joinable);
+			throw e;
+		}
+		log.debug("joined " + joinable);
+	}
+
+	public static void childChangedState(final JoinableParent parent, final Joinable joinable, final JoinableState state) {
+		dispatcherGuardedInvoke(joinable, new RunAt<Object>() {
+			@Override
+			public void run() {
+				log.debug("joinable " + joinable + " is notifying parent " + parent + " about change to " + state);
+				parent.childChangedState(joinable, state);
+			}
+		});
+	}
+
+	public static void wait(Object object, long millis) {
+		try {
+			object.wait(millis);
+		} catch (InterruptedException e) {
+		}
+	}
+
+	public static void joinAbsolutely(Joinable joinable) {
+		log.info("joining absolutely " + joinable);
+		while (true) {
+			try {
+				Dispatching.join(joinable);
+				return;
+			} catch (InterruptedException e) {
+				// throw new FramsticksException().msg("failed to join").arg("dispatcher", dispatcher).cause(e);
+			}
+			log.info("waiting for " + joinable);
+			sleep(500);
+		}
+	}
+
+
+
+
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/Joinable.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Joinable.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Joinable.java	(revision 88)
@@ -0,0 +1,15 @@
+package com.framsticks.util.dispatching;
+
+import javax.annotation.Nonnull;
+
+
+public interface Joinable {
+
+	public boolean use(@Nonnull JoinableParent owner);
+	public boolean drop(@Nonnull JoinableParent owner);
+
+	public void join() throws InterruptedException;
+
+	public JoinableState getState();
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java	(revision 88)
@@ -0,0 +1,139 @@
+package com.framsticks.util.dispatching;
+
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.Map;
+import java.util.Set;
+
+import com.framsticks.core.Entity;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.Misc;
+
+
+@FramsClassAnnotation
+public class JoinableCollection<T extends Joinable> extends AbstractJoinable implements JoinableParent, Iterable<T> {
+
+	protected final Set<T> joinables = new HashSet<T>();
+	protected final Map<String, T> namedJoinables = new HashMap<>();
+
+	protected boolean finishIfOne;
+
+	protected String observableName;
+
+	public JoinableCollection() {
+		this(false);
+	}
+
+	public JoinableCollection(boolean finishIfOne) {
+		this.finishIfOne = finishIfOne;
+	}
+
+	@AutoAppendAnnotation
+	public void add(T joinable) {
+		assert isInState(JoinableState.INITILIAZED);
+
+		if (joinables.contains(joinable)) {
+			throw new FramsticksException().msg("joinable is already observed").arg("joinable", joinable).arg("in", this);
+		}
+		// if (observables.containsKey(observable.getName())) {
+		// 	throw new FramsticksException().msg("observable with given name already exists").arg("name", observable.getName()).arg("in", this);
+		// }
+
+		if (joinable instanceof Entity) {
+			Entity e = (Entity) joinable;
+			if (!namedJoinables.containsKey(e.getName())) {
+				namedJoinables.put(e.getName(), joinable);
+			}
+		}
+
+		joinables.add(joinable);
+	}
+
+	@Override
+	protected void joinableStart() {
+		for (T j : joinables) {
+			Dispatching.use(j, this);
+		}
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		if (joinables.isEmpty()) {
+			finish();
+			return;
+		}
+
+		for (T j : joinables) {
+			Dispatching.drop(j, this);
+		}
+	}
+
+	@Override
+	protected void joinableFinish() {
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		for (T j : joinables) {
+			Dispatching.join(j);
+		}
+	}
+
+	protected JoinableState getNextState() {
+		if (joinables.isEmpty()) {
+			return state;
+		}
+		JoinableState result = finishIfOne ? JoinableState.INITILIAZED : JoinableState.JOINED;
+		for (Joinable j : joinables) {
+			JoinableState s = j.getState();
+			if (finishIfOne) {
+				if (s.ordinal() > result.ordinal()) {
+					result = s;
+				}
+			} else {
+				if (s.ordinal() < result.ordinal()) {
+					result = s;
+				}
+			}
+		}
+		return result;
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(getNextState());
+
+	}
+
+	@Override
+	public Iterator<T> iterator() {
+		return Collections.unmodifiableSet(joinables).iterator();
+	}
+
+	@Override
+	public String toString() {
+		return Misc.returnNotNull(observableName, "collection");
+	}
+
+	/**
+	 * @param observableName the observableName to set
+	 */
+	public JoinableCollection<T> setObservableName(String observableName) {
+		this.observableName = observableName;
+		return this;
+	}
+
+	public T get(String name) {
+		return namedJoinables.get(name);
+	}
+
+
+	public Map<String, T> getObservables() {
+		return Collections.unmodifiableMap(namedJoinables);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/JoinableMonitor.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/JoinableMonitor.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/util/dispatching/JoinableMonitor.java	(revision 88)
@@ -0,0 +1,64 @@
+package com.framsticks.util.dispatching;
+
+import org.apache.log4j.Logger;
+// import edu.umd.cs.findbugs.annotations.SuppressWarnings;
+import com.framsticks.util.dispatching.Dispatching;
+
+public class JoinableMonitor implements JoinableParent {
+	private static final Logger log =
+		Logger.getLogger(JoinableMonitor.class);
+
+	protected final Joinable joinable;
+
+	/**
+	 * @param joinable
+	 */
+	public JoinableMonitor(Joinable joinable) {
+		this.joinable = joinable;
+	}
+
+	public JoinableMonitor waitFor() {
+		log.debug(this + " is waiting");
+		synchronized (this) {
+			while (joinable.getState().ordinal() < JoinableState.FINISHING.ordinal()) {
+				Dispatching.wait(this, 100);
+			}
+		}
+		log.debug(this + " ended waiting");
+		return this;
+	}
+
+	public JoinableMonitor use() {
+		log.debug(this + " is using");
+		Dispatching.use(joinable, this);
+		return this;
+	}
+
+	public JoinableMonitor drop() {
+		log.debug(this + " is droping");
+		Dispatching.drop(joinable, this);
+		return this;
+	}
+
+	public JoinableMonitor join() {
+		log.debug(this + " is joining");
+		Dispatching.joinAbsolutely(joinable);
+		log.debug(this + " is joined");
+		return this;
+	}
+
+	@Override
+	// @SuppressWarnings("NN_NAKED_NOTIFY")
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		synchronized (this) {
+			this.notify();
+		}
+		log.debug(this + " received notification about transition to " + state);
+	}
+
+	@Override
+	public String toString() {
+		return "monitor for " + joinable;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/JoinableParent.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/JoinableParent.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/util/dispatching/JoinableParent.java	(revision 88)
@@ -0,0 +1,7 @@
+package com.framsticks.util.dispatching;
+
+public interface JoinableParent {
+
+	public void childChangedState(Joinable joinable, JoinableState state);
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/JoinableState.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/JoinableState.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/util/dispatching/JoinableState.java	(revision 88)
@@ -0,0 +1,9 @@
+package com.framsticks.util.dispatching;
+
+public enum JoinableState {
+	INITILIAZED,
+	RUNNING,
+	FINISHING,
+	JOINABLE,
+	JOINED
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Thread.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 88)
@@ -5,4 +5,8 @@
 import java.util.LinkedList;
 import java.util.ListIterator;
+
+import javax.annotation.OverridingMethodsMustInvokeSuper;
+
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.dispatching.RunAt;
 
@@ -10,5 +14,5 @@
  * @author Piotr Sniegowski
  */
-public class Thread<C> implements Dispatcher<C> {
+public class Thread<C> extends AbstractJoinable implements Dispatcher<C> {
 
 	private static final Logger log = Logger.getLogger(Thread.class.getName());
@@ -27,18 +31,15 @@
 	}
 
-	public Thread(String s) {
-		this();
-		thread.setName(s);
-		// thread.start();
+	@OverridingMethodsMustInvokeSuper
+	protected void firstTask() {
 	}
 
-	public Thread(String s, java.lang.Thread thread) {
+	public Thread(java.lang.Thread thread) {
 		this.thread = thread;
-		thread.setName(s);
 	}
 
-	public Thread<C> start() {
+	@Override
+	protected void joinableStart() {
 		thread.start();
-		return this;
 	}
 
@@ -49,4 +50,6 @@
 
 	protected void routine() {
+		log.debug("starting thread " + this);
+		firstTask();
 		while (!java.lang.Thread.interrupted()) {
 			Task<? extends C> task;
@@ -76,7 +79,8 @@
 			} catch (Exception e) {
 				log.error("error in thread: " + e);
-				e.printStackTrace();
 			}
 		}
+		log.debug("finishing thread " + this);
+		finish();
 	}
 
@@ -124,15 +128,23 @@
 	}
 
-	public void interrupt() {
+	@Override
+	protected void joinableInterrupt() {
 		thread.interrupt();
 	}
 
-	public void join() throws InterruptedException {
-		thread.join();
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		thread.join(500);
+		log.debug("joined " + this);
 	}
 
+	@ParamAnnotation
 	public void setName(String name) {
 		thread.setName(name);
+	}
 
+	@ParamAnnotation
+	public String getName() {
+		return thread.getName();
 	}
 
@@ -140,3 +152,13 @@
 		return java.lang.Thread.interrupted();
 	}
+
+	@Override
+	public String toString() {
+		return getName();
+	}
+
+	@Override
+	protected void joinableFinish() {
+	}
+
 }
Index: java/main/src/test/java/com/framsticks/core/FramsticksTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/core/FramsticksTest.java	(revision 88)
+++ java/main/src/test/java/com/framsticks/core/FramsticksTest.java	(revision 88)
@@ -0,0 +1,26 @@
+package com.framsticks.core;
+
+import java.io.InputStream;
+
+import org.testng.annotations.Test;
+
+import com.framsticks.gui.Browser;
+import com.framsticks.test.TestConfiguration;
+
+import static org.fest.assertions.Assertions.*;
+
+@Test
+public class FramsticksTest extends TestConfiguration {
+
+	@Test
+	public void testConfiguration() {
+		InputStream stream = FramsticksTest.class.getResourceAsStream("/configs/test.xml");
+		assertThat(stream).isNotNull();
+
+		Framsticks framsticks = Framsticks.loadConfiguration(stream);
+		assertThat(framsticks).isNotNull();
+		assertThat(framsticks.getObservables().size()).isEqualTo(1);
+		assertThat(framsticks.getObservables().get("browser")).isInstanceOf(Browser.class);
+	}
+
+}
Index: java/main/src/test/java/com/framsticks/gui/BrowserTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/gui/BrowserTest.java	(revision 87)
+++ java/main/src/test/java/com/framsticks/gui/BrowserTest.java	(revision 88)
@@ -3,5 +3,4 @@
 import javax.swing.JFrame;
 
-import org.apache.commons.configuration.PropertiesConfiguration;
 import org.apache.log4j.Logger;
 import org.fest.swing.edt.FailOnThreadViolationRepaintManager;
@@ -16,4 +15,7 @@
 import com.framsticks.remote.RemoteInstance;
 import com.framsticks.test.TestConfiguration;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.JoinableMonitor;
+// import com.framsticks.util.dispatching.Dispatching;
 
 import static org.fest.assertions.Assertions.*;
@@ -25,4 +27,5 @@
 	private static final Logger log = Logger.getLogger(BrowserTest.class);
 
+	JoinableMonitor monitor;
 	Browser browser;
 	Robot robot;
@@ -37,5 +40,5 @@
 
 		browser = new Browser();
-		browser.configure(new PropertiesConfiguration());
+		monitor = new JoinableMonitor(browser);
 
 		RemoteInstance localhost = new RemoteInstance();
@@ -43,7 +46,7 @@
 		localhost.setAddress("localhost:9009");
 
-		browser.addEndpointForInstance(localhost);
+		browser.addInstance(localhost);
 
-		browser.start();
+		monitor.use();
 		// robot.waitForIdle();
 		frame = new FrameFixture(robot,
@@ -51,5 +54,5 @@
 					@Override
 					protected JFrame executeInEDT() throws Throwable {
-						return browser.getMainFrame();
+						return browser.getMainFrame().getSwing();
 					}
 				}));
@@ -86,4 +89,10 @@
 		clickAndExpandPath(tree, "localhost/simulator/genepools/groups");
 		clickAndExpandPath(tree, "localhost/simulator/genepools/groups/Genotypes");
+
+
+
+
+
+
 		// tree.clickPath("localhost/simulator/genepools/groups/Genotypes/genotypes");
 		// robot.waitForIdle();
@@ -97,16 +106,28 @@
 	}
 
-	public void sleep(int seconds) {
-		try {
-			Thread.sleep(seconds * 1000, 0);
-		} catch (InterruptedException e) {
-			e.printStackTrace();
-		}
-	}
 
 	@AfterClass
 	public void tearDown() {
-		// frame.close();
-		frame.cleanUp();
+		log.info("before close");
+
+		monitor.drop();
+
+		Dispatching.joinAbsolutely(browser);
+		// frame.cleanUp();
+		// log.info("before close");
+		// browser.interrupt();
+
+		// try {
+		// 	// frame.close();
+		// } catch (Throwable t) {
+		// 	log.error("caught ", t);
+		// }
+		// log.info("after close");
+		// // frame.close();
+		// // frame.cleanUp();
+
+
+
+		// Dispatching.join(browser);
 	}
 
Index: java/main/src/test/java/com/framsticks/model/f0/SchemaTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/model/f0/SchemaTest.java	(revision 88)
+++ java/main/src/test/java/com/framsticks/model/f0/SchemaTest.java	(revision 88)
@@ -0,0 +1,28 @@
+package com.framsticks.model.f0;
+
+import org.testng.annotations.*;
+
+import com.framsticks.params.types.FloatParam;
+import com.framsticks.test.TestConfiguration;
+import com.framsticks.model.f0.Schema;
+
+import static org.fest.assertions.Delta.*;
+
+import static org.fest.assertions.Assertions.*;
+
+public class SchemaTest extends TestConfiguration {
+
+	@Test
+	public void loadSchemaWithXmlLoader() {
+		Schema schema = Schema.load(Schema.getDefaultDefinitionAsStream());
+		assertThat(schema.getFramsClasses().size()).isEqualTo(5);
+		assertThat(schema.getNeuroClasses().size()).isEqualTo(21);
+
+		assertThat(schema.getNeuroClass("|").getName()).isEqualTo("Bend muscle");
+		assertThat(schema.getNeuroClass("VEye").getParam("p")).isInstanceOf(FloatParam.class);
+		assertThat(schema.getNeuroClass("VEye").getParamEntry("p", FloatParam.class).getMax(Double.class)).isEqualTo(10.0, delta(0.0));
+
+		assertThat(schema.getFramsClass("p").getParamEntry("as", FloatParam.class).getDef(Double.class)).isEqualTo(0.25, delta(0.0));
+	}
+
+}
Index: java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java	(revision 87)
+++ java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java	(revision 88)
@@ -20,5 +20,5 @@
 		builderFramsClass = FramsClass.build().forClass(ParamBuilder.class);
 
-		assertThat(builderFramsClass.getParamCount()).isEqualTo(6);
+		assertThat(builderFramsClass.getParamCount()).isEqualTo(10);
 		assertThat(builderFramsClass.getName()).isEqualTo("prop");
 		assertThat(builderFramsClass.getId()).isEqualTo("prop");
Index: java/main/src/test/java/com/framsticks/parsers/F0ParserTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/parsers/F0ParserTest.java	(revision 87)
+++ java/main/src/test/java/com/framsticks/parsers/F0ParserTest.java	(revision 88)
@@ -5,4 +5,5 @@
 import com.framsticks.model.*;
 import com.framsticks.model.Package;
+import com.framsticks.model.f0.Schema;
 import com.framsticks.params.*;
 import com.framsticks.params.types.FloatParam;
@@ -29,5 +30,5 @@
 	@BeforeClass
 	public void setUp() throws Exception {
-		schema = new Schema(Schema.getDefaultDefinitionAsStream());
+		schema = Schema.load(Schema.getDefaultDefinitionAsStream());
 		Package.register(schema.getRegistry());
 	}
@@ -35,5 +36,5 @@
 	@Test
 	public void primitiveParam() {
-		FramsClass joint = schema.getRegistry().getInfoFromCache("j");
+		FramsClass joint = schema.getFramsClass("j");
 		PrimitiveParam<?> dx = joint.getParamEntry("dx", PrimitiveParam.class);
 		assertThat(dx).isInstanceOf(FloatParam.class);
@@ -47,4 +48,7 @@
 	@Test
 	public void readF0() throws IOException, ParseException {
+		assertThat(schema.getFramsClass("p")).isInstanceOf(FramsClass.class);
+		assertThat(schema.getRegistry().getInfoFromCache("p").getParamEntry("as", FloatParam.class).getDef(Double.class)).isEqualTo(0.25, delta(0.0));
+
 		accesses = new F0Parser(schema, F0ParserTest.class.getResourceAsStream("/parsers/f0_example.txt")).parse();
 
@@ -75,4 +79,5 @@
 		assertThat(model.getJoints().get(0).part1).isEqualTo(0);
 		assertThat(model.getJoints().get(0).part2).isEqualTo(1);
+		assertThat(model.getNeuroDefs().size()).isEqualTo(6);
 		assertThat(model.getNeuroDefs().get(0).part).isEqualTo(1);
 		assertThat(model.getNeuroDefs().get(0).joint).isEqualTo(-1);
@@ -89,4 +94,6 @@
 	public void print() throws Exception {
 		ListSink sink = new ListSink();
+
+
 		new F0Writer(schema, model, sink).write();
 
Index: java/main/src/test/java/com/framsticks/running/ExternalProcessTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/running/ExternalProcessTest.java	(revision 88)
+++ java/main/src/test/java/com/framsticks/running/ExternalProcessTest.java	(revision 88)
@@ -0,0 +1,49 @@
+package com.framsticks.running;
+
+
+// import java.util.Arrays;
+import java.util.Arrays;
+import java.util.LinkedList;
+import java.util.List;
+
+import org.testng.annotations.Test;
+
+import com.framsticks.test.TestConfiguration;
+import com.framsticks.util.dispatching.JoinableMonitor;
+
+import static org.fest.assertions.Assertions.*;
+
+@Test
+public class ExternalProcessTest extends TestConfiguration {
+
+	@Test
+	public void runBash() throws InterruptedException {
+		final ExternalProcess process = new ExternalProcess();
+		process.setCommand("bash");
+
+		final List<String> input = Arrays.asList("test", "another line");
+		final List<String> output = new LinkedList<>();
+
+		process.addListener(new OutputListener() {
+			@Override
+			public void onLineRead(String line) {
+				output.add(line);
+			}
+		});
+		JoinableMonitor monitor = new JoinableMonitor(process);
+		monitor.use();
+
+		for (String l : input) {
+			process.getInput().println("echo " + l);
+		}
+
+		process.getInput().close();
+
+		monitor.waitFor();
+		monitor.drop();
+		monitor.join();
+
+		assertThat(output).isEqualTo(input);
+	}
+
+}
Index: java/main/src/test/java/com/framsticks/running/FramsServerTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/running/FramsServerTest.java	(revision 88)
+++ java/main/src/test/java/com/framsticks/running/FramsServerTest.java	(revision 88)
@@ -0,0 +1,28 @@
+package com.framsticks.running;
+
+import org.testng.annotations.Test;
+
+import com.framsticks.core.Framsticks;
+import com.framsticks.remote.RemoteInstance;
+import com.framsticks.test.TestConfiguration;
+
+import static org.fest.assertions.Assertions.*;
+
+@Test
+public class FramsServerTest extends TestConfiguration {
+
+	@Test
+	public void runServer() {
+		Framsticks framsticks = Framsticks.loadConfiguration(FramsServerTest.class.getResourceAsStream("/configs/FramsServerTest.xml"));
+
+		assertThat(framsticks.getObservables().size()).isEqualTo(2);
+		assertThat(framsticks.getObservables().get("frams")).isInstanceOf(FramsServer.class);
+		assertThat(framsticks.getObservables().get("remote")).isInstanceOf(RemoteInstance.class);
+
+		// framsticks.start();
+
+		// framsticks.waitForObservables();
+
+	}
+
+}
Index: java/main/src/test/java/com/framsticks/test/TestConfiguration.java
===================================================================
--- java/main/src/test/java/com/framsticks/test/TestConfiguration.java	(revision 87)
+++ java/main/src/test/java/com/framsticks/test/TestConfiguration.java	(revision 88)
@@ -11,7 +11,7 @@
 
 	@BeforeClass
-	public static void setUpConfiguration() {
+	public void setUpConfiguration() {
 		PropertyConfigurator.configure(TestConfiguration.class.getResource("/log4j.properties"));
-		log.info("logging configured");
+		log.info("testing " + this.getClass());
 	}
 
